goog.provide 'app.document.Reference'
goog.provide 'app.ReferenceLike'
###*
  @typedef {{
    title: string
  }}
###
app.ReferenceLike

class app.document.Reference

  ###*
    @enum {string}
  ###
  @Type = {
    Abbreviation: 'abbreviation'
    Citation: 'citation'
    Link: 'link'
    Term: 'term'
  }

  ###*
    @constructor
  ###
  constructor: ->

    ###*
      @type {string}
      @expose
    ###
  _id: ''

  ###*
    @type {string}
    @expose
  ###
  _rev: ''

  ###*
    @type {string}
    @expose
  ###
  title: ''

  ###*
    @type {string}
    @expose
  ###
  type: ''

class app.document.Link extends app.document.Reference
  ###*
    @constructor
    @extends {app.document.Reference}
  ###
  constructor: ->

  ###*
    @type {string}
  ###
  url: ''

class app.document.Abbreviation extends app.document.Reference
  ###*
    @constructor
    @extends {app.document.Reference}
  ###
  constructor: ->

  ###*
    The word or words it shortens.
    @type {string}
  ###
  fullTitle: ''

class app.document.Term extends app.document.Reference
  ###*
    @constructor
    @extends {app.document.Reference}
  ###
  constructor: ->

  ###*
    Text which explains the term as is used in document.
    @type {string}
  ###
  description: ''

class app.document.Citation extends app.document.Reference
  ###*
    @constructor
    @extends {app.document.Reference}
  ###
  constructor: ->

  ###*
    Text for standard citation in given country.
    @type {string}
  ###
  citation: ''