goog.provide 'app.editor.TextEditor'

goog.require 'goog.editor.SeamlessField'
goog.require 'goog.ui.Textarea'
goog.require 'goog.events'

###
  Props:
  @type {string} id - id to put into DOM, for goog.editor
  @type {function} onEditorChange - to save editor contents
  @type {string} initText - the initial text
###

do ->
  {div} = React.DOM

  app.editor.TextEditor.reactClass = React.createClass(
    displayName: 'text-editor'

    getInitialState: ->
      return {
        shouldSave: true
      }

    render: ->
      React.DOM.textarea(
        {
          className: 'editor'
          id: @props.id
          ref: 'textarea'
          defaultValue: @props.initText
          onChange: @onChange
          onBlur: @onDelayedChange
        }
      )

    componentDidMount: ->
      @applyTextarea()

    applyTextarea: ->
      @textarea = new goog.ui.Textarea('')
      @textarea.decorate(@getDOMNode())

    onChange: (e) ->
      if @state.shouldSave
        @onDelayedChange(e)

    onDelayedChange: (e) ->
      @props.onContentChange e.target.value
      @setState({shouldSave: false})
      setTimeout(@toggleShouldSaveState, 250)

    toggleShouldSaveState: ->
      # async...
      @setState {shouldSave: true} if @isMounted()

  )
