goog.provide 'app.BlockType'

###*
  @enum {string}
###
app.BlockType = {
  Document: 'document'
  List: 'list'
  Paragraph: 'paragraph'
  Section: 'section'
  Image: 'image'
}


###*
  @private
###
app.BlockType.structures = [
  app.BlockType.Section
]

###*
  @private
###
app.BlockType.text = [
  app.BlockType.List
  app.BlockType.Paragraph
]

###*
  @private
###
app.BlockType.data = [
  app.BlockType.Image
]
#  types = Object.keys(app.BlockType)
#  types.forEach (key) -> key.toLowerCase()
#  return types

###*
  @private
###
app.BlockType.all = do ->
  app.BlockType.structures.concat(app.BlockType.text, app.BlockType.data)

allExcept = (ignoreTypes) ->
  types = app.BlockType.structures.concat(app.BlockType.text, app.BlockType.data)
  for type in ignoreTypes
    idx = types.indexOf(type)
    types.splice(idx, 1)
  return types

###* @private ###
app.BlockType.allForSection = do -> allExcept([app.BlockType.Section])

###*
  @return {Array.<app.BlockType>}
  @public
###
app.BlockType.getAll = ->
  return app.BlockType.all

###*
  @return {Array.<app.BlockType>}
  @public
###
app.BlockType.getAllForSection = ->
  return app.BlockType.allForSection

app.BlockType.getElementsInterchangeable = ->
  return [app.BlockType.List, app.BlockType.Paragraph]

###*
  @param {app.BlockType} type
  @public
###
app.BlockType.isStructure = (type) ->
  return (app.BlockType.structures.indexOf(type) != -1)

###*
  Elements are:
    - list
    - paragraph
    - image
  @param {app.document.Block} block
  @return {boolean}
  @public
###
app.BlockType.isElement = (block) ->
  return (
    [
      app.BlockType.Paragraph, app.BlockType.List, app.BlockType.Image
    ].indexOf(block.type) != -1
  )