goog.require 'app.testUtils'
goog.require 'app.domAssert'

suite 'app.editor.ElementPane', ->
  ElementPane = app.editor.ElementPane.reactClass

  setup ->
    @pane = ElementPane {
      block: {
        type: 'list'
        tags: []
      }
      types: ['list', 'p', 'img']
    }

    React.renderComponent(@pane, document.body)
    @el = document.body

  test 'init ok', ->
    assert.ok @pane

  suite 'type selection', ->

    test 'current type is selected', ->
      app.domAssert.hasSelectWithDefault(@el, 'list')

    test 'all other types are options', ->
      app.domAssert.hasOptionCount(@el, 3)

  teardown ->
    app.testUtils.resetElement(@el)