goog.provide 'app.editor.MetaPanel'

goog.require 'app.editor.ElementPane'
goog.require 'app.editor.NotePane'
goog.require 'app.ui.IconButton'
goog.require 'app.PaneType'

class app.editor.MetaPanel

  ###*
    @constructor
  ###
  constructor: ->
    {div, input, option, select, a, ul} = React.DOM
    ElementPane = app.editor.ElementPane.reactClass
    NotePane = app.editor.NotePane.reactClass
    IconButton = app.ui.IconButton.component

    @reactClass = React.createClass(

      getDefaultProps: ->
        return {
          activePanel: app.PaneType.Element
          panes: [
            {isActive: false, title: app.PaneType.Element, icon: 'list'}
            {isActive: false, title: app.PaneType.Comment, icon: 'comment'}
            {isActive: false, title: app.PaneType.AuthorNotes, icon: 'pencil'}
          ]
        }

      getInitialState: ->
        return {
          ###*
            @type {number}
          ###
          activePanelIdx: 0
        }

      render: ->
        div(
          {className: 'pane element'}
          @metaPanel()
          @actionsIcons()
          @metaEditor()
        )

      actionsIcons: ->
        ul(
          {className: 'block-actions'}
          @actionIcon('view', 'search')
        )

      actionIcon: (title, icon) ->
        React.DOM.li({}
          React.DOM.a(
            {title: "#{title}", className: "btn btn-primary btn-sm", href: @props.blockViewRoute}
            React.DOM.span({className: "glyphicon glyphicon-#{icon}"})
          )
        )

      onPaneChange: (pane) ->
        index = @props.panes.indexOf pane
        if @state.activePanelIdx == index
          @setState {activePanelIdx: undefined}
        else
          @setState {activePanelIdx: index}

      onCommentChange: (newComment) ->
        @props.onCommentChange @props.block, newComment

      onNoteChange: (newComment) ->
        @props.onNoteChange @props.block, newComment

      metaEditor: ->
        return unless @state.activePanelIdx?
        metaEditor = switch (this.props.panes[this.state.activePanelIdx].title)
          when app.PaneType.Element
            ElementPane({
              types: @props.types
              block: @props.block
              onTypeChange: @props.onTypeChange
              typeOptions: @props.typeOptions
            })
          when app.PaneType.Comment
            NotePane({
              note: @props.block.comment
              type: 'comment'
              onNoteChange: @onCommentChange
              placeholder: 'This is a comment.'
            })
          when app.PaneType.AuthorNotes
            NotePane({
              note: @props.block.authorNote
              type: 'note'
              onNoteChange: @onNoteChange
              placeholder: 'This is author note for you.'
            })
          else
            console.warn('no pane type')

        return metaEditor

      metaPanel: ->
        activePane = @props.panes[@state.activePanelIdx]
        buttons = @props.panes.map (pane) =>
          pane['onClick'] = @onPaneChange.bind(this, pane)
          pane['isActive'] = pane is activePane
          pane['key'] = pane.title
          IconButton(pane)

        return React.DOM.ul({className: "meta-panel"},
          buttons
        )
    )
