goog.require 'tests.Factory'

shortcuts = {}
SectionModule = new app.editor.Section(shortcuts)

suite 'app.editor.Section', ->
  Section = SectionModule.reactClass

  createBlock = tests.Factory.Section.create
  createView = (props) -> new Section(props)

  ###*
    @params {Object} props
    @returns {React.ReactComponent} component
  ###
  createViewRedux = (
    {
      block, renderBlocks, onAppendBlock, canNestSection
    }
  ) ->
    props = {
      block: block || {}
      renderBlocks: renderBlocks || ->
      onAppendBlock: onAppendBlock || ->
      canNestSection: canNestSection || false
    }
    return new Section(props)

  ###*
    @params {Object=} props - just passing
    @returns {string} component
  ###
  renderToStringRedux = (props={}) ->
    view = createViewRedux props
    return React.renderComponentToStaticMarkup(view)

  test 'init ok', ->
    section = createView()
    assert.ok section

  suite 'view with default props', ->
    setup ->
      @viewStr = renderToStringRedux(
        block: {title: 'Caffé latte'}
      )

    test 'hides add section btn', ->
      assert.notInclude @viewStr, 'add section'

    test 'shows its title', ->
      assert.include @viewStr, 'Caffé latte'

  suite 'toggled default props', ->
    test 'hides add section button, if can nest', ->
      @viewStr = renderToStringRedux({
        canNestSection: true
      })
      assert.include @viewStr, 'add section'


  test 'renders blocks', ->
    renderBlocks = sinon.spy()
    blocks = [{}, {}].map createBlock
    props = {
      block: createBlock {blocks}
      renderBlocks: renderBlocks
    }
    renderToStringRedux props
    assert.ok renderBlocks.called
    assert.ok renderBlocks.calledWith blocks

