goog.provide 'app.formatter.ImagesFormatter'

goog.require 'app.formatter.ImageSettings'
goog.require 'app.viewer.Image'

do ->
  {img, div, button, h2} = React.DOM
  ImageView = app.viewer.Image.reactClass
  loremParagraph = 'Rhoncus. Orci malesuada lectus, morbi rhoncus litora ut nascetur. Pellentesque conubia curae per vestibulum. Mus scelerisque feugiat sollicitudin blandit. Cum urna urna mus felis proin, mollis sapien risus ipsum primis. Mi lectus sollicitudin elementum litora aenean, vulputate id, malesuada arcu. Leo, proin phasellus lacinia pellentesque fermentum nulla in lacus. Pede consequat fringilla urna suspendisse natoque, leo. Nam elit dui vitae velit. Ridiculus duis, nisl penatibus sociosqu, libero nisl cubilia ipsum ve arcu, odio arcu dis netus. At. Tortor. Ac, facilisis purus ve nisl.'
  app.formatter.ImagesFormatter.reactClass = React.createClass(

    render: ->
      imagesFormatView = 'No images in document.'
      if @props.images.length
        imagesFormatView = @props.images.map (image) => @imageFormatView image

      return div(
        {}
        h2({}, 'Images')
        imagesFormatView
      )

    ###*
      @param {app.document.Image} image
    ###
    imageFormatView: (image) ->
      return div(
        {className: 'img-format-view'}
        div(
          {className: 'img-view'}
          ImageView({image: image})
          loremParagraph
        )
        'Choose image format: '
        @imageFormatChoose(image)
      )

    ###*
      @param {app.document.Image} image
    ###
    imageFormatChoose: (image) ->
      return div(
        {className: 'btn-group', role: 'group'}
#        @imageFormatButton(image, 'left', app.formatter.ImageSettings.Format.FloatLeft)
        @imageFormatButton(image, 'full width', app.formatter.ImageSettings.Format.FullWidth)
        @imageFormatButton(image, 'right', app.formatter.ImageSettings.Format.FloatRight)
      )

    imageFormatButton: (image, name, format) ->
      isActive = (image.formatSettings.format == format)
      activeClass = if isActive then 'btn-primary' else 'btn-default'
      button(
        {
          className: "btn #{activeClass}"
          onClick: => @props.onImageFormatChosen(image, format)
        }
        name
      )


  )