goog.provide 'app.object'

app.object = {
  ###*
    Override values of corresponding keys of given
    object if they are true, but the existing are not.
    @param {Object} object - to override
    @param {Object} source - to get values from
  ###
  overrideIfTruthy: (object, source) ->
    for key, val of source
      if !object[key] and !!val
        object[key] = val

  ###*
    Recursively extends object with defined properties of source
    @param toExtend {Object}
    @param source {Object}
  ###
  _extendUndefined: (toExtend, source) ->
    for key, val of source
      if source[key]?
        toExtend[key] = val
      else if source[key]? && typeof source[key] == 'object'
        app.object._extendUndefined(toExtend[key], source[key])
}