goog.provide 'app.main'

goog.require 'App'
goog.require 'app.StateStorage'
goog.require 'app.document.Storage'
goog.require 'app.DiContainer'

###
  Whether debug or production. Only important information.
###
app.debug = false

###
  Log everything.
###
app.lamebug = false

app.reportError = (err) -> console.error(err)

###*
  App init point.
  @param {Object} data
###
app.main = (data) ->
  # DiContainer is goodness. Read: https://github.com/steida/closure-dicontainer
  container = new app.DiContainer

  # Here we can pass runtime values to any class in project or library.
  container.configure
    resolve: App
    with: element: document.querySelector '#docsapp'
  ,
    resolve: app.document.Storage
    with: db: new PouchDB(app.document.Storage.DB_NAME)
  ,
    resolve: este.History
    # By default history uses autodetection. We can enforce hashchange.
    by: -> new este.History forceHash: true

  # This method will build whole app for us. No more factories everywhere.
  # If you are curious what happens, take a look at App class.
  container.resolveApp()

goog.exportSymbol 'app.main', app.main


