goog.provide 'app.ui.StructuredMixin'

goog.require 'app.ui.RemoveButton'
goog.require 'app.ui.AppendButton'
goog.require 'app.BlockType'

app.ui.StructuredMixin = {
  ###*
    @param {app.BlockType} type
  ###
  addBtn: (type) ->
    app.ui.AppendButton.component({
      type: type
      appendHandler: @props.onAppendBlock.bind(null, @props.block, type)
    })

  onRemove: ->
    @props.onRemove @props.block

  onTitleChange: (event) ->
    title = event.target.value
    @props.onChange @props.block, {title}

  removeBtn: ->
    app.ui.RemoveButton({title: "remove #{@props.block.type}", onRemove: @onRemove, classSuffix: @props.block.type})

  renderHeader: ->
    type = @props.block.type
    React.DOM.div(
      {className: 'section-attrs'}
      React.DOM.input(
        {
          value: @props.block.title
          onChange: @onTitleChange
          className: "#{type}-title"
          placeholder: "new #{type}"
        }
      )
      @removeBtn()
    )

}
